DEFine PROCedure setDate(mfile$,ddate)
  local chan%
  chan%=fopen(mfile$)
  set_fupdt #chan%,ddate
  close#chan%
END DEFine setDate
:
DEFine fn backup_file% (bsource$,bdest$,repchan%)
rem backup one file
rem returns 1 if backup ok, 0 if not
LOCal chan%,fidate,filength,address,fitype,fidata,temp%
  pe_cls#repchan%,3
  at#repchan%,2,0:pe_print#repchan%,"Backing up: "&bsource$
  chan%=fop_in(bsource$)
  if chan%<0
    dr_unst warn_defn
    temp%=warning% ("Couldn't backup file : "&bsource$& "  "&errstr$(chan%),repchan%,"Error")
    info "",repchan%
    return  0
  endif
  fidate=fupdt(#chan%)
  filength=flen(#chan%)
  fitype=ftyp(#chan%)
  if fitype=1 or fitype=7
    fidata=fdat(#chan%)
  endif
  close#chan%
  if filength>backup_size
     rechp backup_address
     backup_address=alchp(filength)
     backup_size=filength
  endif
  lbytes bsource$,backup_address
  select on fitype
    =0
	sbytes_o bdest$,backup_address,filength
    =1
	sexec_o bdest$,backup_address,filength,fidata
    =remainder
	sbytes_o bdest$,backup_address,filength
	chan%=fopen(bdest$)
	sethdrt#chan%,fitype
	if fitype=7: sethdrd#chan%,fidata
	close#chan%
  end select
  setdate bdest$,fidate
  return 1
END DEFine backup_file%
:
def proc backup (choice%,item%,chan%)
rem choice% is the choice from the right click menu
local result_count%,a$,sourcelen%,lp%,result_ok%,s_dev$,b$,status%
  result_count%=0			: rem will contain the nbr of files to backup
  dim backup$(dimn(result$,1),dimn(result$,2))
  setup_backup choice%,item%		: rem fill in the backup$ array
  if result_count%=0:return		: rem nothing to backup
  info "",chan%
  if options%(4)>20
     result_ok%=create_missing_directories%(chan%) : rem actually <> 0 if NOT OK
     if result_ok%
	result_ok%=fop_over("ram1_wlBackupwlxxx1")
	if result_ok%>-1
	   print#result_ok%,errdir$
	   close#result_ok%
	endif
	dr_unst warn_defn
	result_ok%=warning%(sometexts$(0)&chr$(10)&sometexts$(1)&chr$(10)&sometexts$(2),chan%,sometexts$(3))
	if result_ok%=0:return
	info "",chan%
      endif
  endif
  backup_size=1000
  backup_address=alchp(backup_size)
  sourcelen%=len(source$)-5
  s_dev$=source$(1 to 5)
  for lp%=0 to result_count%-1
    a$=backup$(lp%)
    if sourcelen%
       b$=a$(sourcelen%+1 to)
    else
       b$=a$
    endif
    result_ok%=backup_file%( s_dev$&a$,dest$&b$,chan%)
    if result_ok%
      if options%(3)<>0
	status%=17			: rem make unavailable
      else
	status%=1			: rem set to available
      endif
      if options%(2)>20
	change_status_of_one_item_in_all_tabs a$,status%
      else
	change_status_in_current_tab a$,status%
      endif
    endif
  end for lp%
  get_new_statusses
  dr_unst warn_defn
  rechp backup_address
end def backup
:
def proc setup_backup (choice%,item%)
rem determines which files must be backed up, and
rem puts the result into a global var backup$ created here
local lp%
  dim backup$(dimn(result$,1),dimn(result$,2))
  select on choice%
    = 0 : rem backup only this file
	result_count%=1
	backup$(0)=get_file$(item%)
    = 1 : rem backup all selected files of current tab
	backup_current_tab 0
    = 2 : rem backup all files of current tab
	backup_current_tab 1
    = 3 : rem backup all selected files of all tabs
	backup_all_tabs 0
    = 4 : rem backup all files in all tabs
	backup_all_tabs 1
  end select
end def setup_backup
:
def proc backup_current_tab (do_all%)
rem backup the current tab, as determined by current choice
rem do_all% <>01 if all files in this tab are to be abcked up, else only the selected ones
  select on current_choice%
    =0: get_files_to_backup result$ ,tot_objs%,do_all%
    =1: get_files_to_backup nonexistent$, non_ext%,do_all%
    =2: get_files_to_backup typediff$, type_d% ,do_all%
    =3: get_files_to_backup lengthdiff$,length_d% ,do_all%
    =4: get_files_to_backup diffdate$, date_d% ,do_all%
    =5: get_files_to_backup contdiff$,cont_d%,do_all%
rem    =6: get_files_to_backup impossible$,imp_d%,do_all% : rem this doesn't make sense
  end select
end def backup_current_tab
:
def proc backup_all_tabs (do_all%)
local oldchoice%,lp%
  if do_all%
    backup_all_files
  else
    oldchoice%=current_choice%
    for lp% = 0 to 5
       current_choice%=lp%	: rem lp% shouldn't be extended to 6 as that tab can't be backed up
       backup_current_tab do_all%
    end for lp%
  endif
end def backup_all_tabs
:
def fn get_file$(item%)
  select on current_choice%
    =0: return strip_spaces$(result$(item%+1,1 to name_length%)) : rem if in "all" tab
    =1: return strip_spaces$(nonexistent$(item%+1,1 to name_length%))
    =2: return strip_spaces$(typediff$(item%+1,1 to name_length%))
    =3: return strip_spaces$(lengthdiff$(item%+1,1 to name_length%))
    =4: return strip_spaces$(diffdate$(item%+1,1 to name_length%))
    =5: return strip_spaces$(contdiff$(item%+1,1 to name_length%))
    = remainder : return ""
  end select
end def get_file$
:
def proc get_files_to_backup (string$,flags%,do_all%)
rem this fills the backup$ array with the names of the source files to backup
local lp%,a$
  for lp%=0 to dimn(flags%,1)
    if (do_all%) or (flags%(lp%,0) >1)
	a$=strip_spaces$(string$(lp%+1,1 to name_length%)) : rem the file to backup
	if a$<>"" and asearch(backup$,a$,0,0)=-1
	   backup$(result_count%)=a$	: rem put it into result array but only if it isn't there aleady
	   result_count%=result_count%+1
	endif
    endif
  end for lp%
end def get_files_to_backup
:
def proc backup_all_files
rem backing up all files is easy: just backup all files in the "all" tab
local lp%
  result_count%= dimn(result$,1)-1
  for lp%=0 to result_count%
    backup$(lp%)=strip_spaces$(result$(lp%+1,1 to name_length%))
  end for lp%
end def backup_all_files
:
